#include <windows.h>
#include <stdio.h>
#include <conio.h>

typedef int (__stdcall *ShowDll)(void);
typedef int (__stdcall *getString)(char* buf, int sz);
typedef int (__stdcall *callexport)(void);
typedef int (__stdcall *recvstring)(char* str);
typedef int (__stdcall *callback)(int lpfn);

#define EXPORT comment(linker, "/EXPORT:"__FUNCTION__"="__FUNCDNAME__)


void __stdcall MyCExport(void){
#pragma EXPORT
	printf("MyCExport ran!\n");
}

void main(int argc, char* argv[]){

	ShowDll dll;
	getString gs;
	callexport ce;
	recvstring rs;
	callback cb;

	if(argc==1){
		printf("usage: loader.exe <test.dll>");
		exit(0);
	}

	printf("trying to load: %s\n", argv[1]);

	HMODULE h = LoadLibrary(argv[1]);
	
	if(h==0){
		printf("load failed press any key to exit...");
		getch();
		exit(0);
	}

	printf("Library base = %x\n", h);

	dll = (ShowDll)GetProcAddress(h,"ShowDllForm");
	int d = dll();
	printf("Calling ShowDllForm() = %d\n", d);
	
	gs = (getString)GetProcAddress(h,"GetString");
	//printf("gs=%x\n", gs);
	
	char* tmp = (char*)malloc(100);
	memset(tmp, 'a', 100);
	int ret = gs(tmp, 100);
	printf("GetString returned=%d string is: %s\n", ret, tmp);
	 
	ce = (callexport)GetProcAddress(h,"CallExport");
	printf("Calling CallExport() *ce=%x\n", ce);
	ce();

	rs = (recvstring)GetProcAddress(h,"RecvString");
	printf("Calling RecvString *rs=%x\n", rs);
	rs(tmp);

	cb = (callback)GetProcAddress(h,"CallBack");
	printf("Calling CallBack(*Cfunc) cb=%x\n", cb);
	cb((int)MyCExport);

	getch();


}